# Rust API for ops-v3

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

## Overview
This client/server was generated by the [openapi-generator]
(https://openapi-generator.tech) project.
By using the [OpenAPI-Spec](https://github.com/OAI/OpenAPI-Specification) from a remote server, you can easily generate a server stub.
-

To see how to make this your own, look here:

[README]((https://openapi-generator.tech))

- API version: 0.0.1

This autogenerated project defines an API crate `ops-v3` which contains:
* An `Api` trait defining the API in Rust.
* Data types representing the underlying data model.
* A `Client` type which implements `Api` and issues HTTP requests for each operation.
* A router which accepts HTTP requests and invokes the appropriate `Api` method for each operation.

It also contains an example server and client which make use of `ops-v3`:
* The example server starts up a web server using the `ops-v3` router,
  and supplies a trivial implementation of `Api` which returns failure for every operation.
* The example client provides a CLI which lets you invoke any single operation on the
  `ops-v3` client by passing appropriate arguments on the command line.

You can use the example server and client as a basis for your own code.
See below for [more detail on implementing a server](#writing-a-server).


## Examples

Run examples with:

```
cargo run --example <example-name>
```

To pass in arguments to the examples, put them after `--`, for example:

```
cargo run --example client -- --help
```

### Running the server
To run the server, follow these simple steps:

```
cargo run --example server
```

### Running a client
To run a client, follow one of the following simple steps:

```
cargo run --example client Op10Get
cargo run --example client Op11Get
cargo run --example client Op12Get
cargo run --example client Op13Get
cargo run --example client Op14Get
cargo run --example client Op15Get
cargo run --example client Op16Get
cargo run --example client Op17Get
cargo run --example client Op18Get
cargo run --example client Op19Get
cargo run --example client Op1Get
cargo run --example client Op20Get
cargo run --example client Op21Get
cargo run --example client Op22Get
cargo run --example client Op23Get
cargo run --example client Op24Get
cargo run --example client Op25Get
cargo run --example client Op26Get
cargo run --example client Op27Get
cargo run --example client Op28Get
cargo run --example client Op29Get
cargo run --example client Op2Get
cargo run --example client Op30Get
cargo run --example client Op31Get
cargo run --example client Op32Get
cargo run --example client Op33Get
cargo run --example client Op34Get
cargo run --example client Op35Get
cargo run --example client Op36Get
cargo run --example client Op37Get
cargo run --example client Op3Get
cargo run --example client Op4Get
cargo run --example client Op5Get
cargo run --example client Op6Get
cargo run --example client Op7Get
cargo run --example client Op8Get
cargo run --example client Op9Get
```

### HTTPS
The examples can be run in HTTPS mode by passing in the flag `--https`, for example:

```
cargo run --example server -- --https
```

This will use the keys/certificates from the examples directory. Note that the server chain is signed with
`CN=localhost`.


## Writing a server

The server example is designed to form the basis for implementing your own server. Simply follow these steps.

* Set up a new Rust project, e.g., with `cargo init --bin`.
* Insert `ops-v3` into the `members` array under [workspace] in the root `Cargo.toml`, e.g., `members = [ "ops-v3" ]`.
* Add `ops-v3 = {version = "0.0.1", path = "ops-v3"}` under `[dependencies]` in the root `Cargo.toml`.
* Copy the `[dependencies]` and `[dev-dependencies]` from `ops-v3/Cargo.toml` into the root `Cargo.toml`'s `[dependencies]` section.
  * Copy all of the `[dev-dependencies]`, but only the `[dependencies]` that are required by the example server. These should be clearly indicated by comments.
  * Remove `"optional = true"` from each of these lines if present.

Each autogenerated API will contain an implementation stub and main entry point, which should be copied into your project the first time:
```
cp ops-v3/examples/server.rs src/main.rs
cp ops-v3/examples/server_lib/mod.rs src/lib.rs
cp ops-v3/examples/server_lib/server.rs src/server.rs
```

Now

* From `src/main.rs`, remove the `mod server_lib;` line, and uncomment and fill in the `extern crate` line with the name of this server crate.
* Move the block of imports "required by the service library" from `src/main.rs` to `src/lib.rs` and uncomment.
* Change the `let server = server::Server {};` line to `let server = SERVICE_NAME::server().unwrap();` where `SERVICE_NAME` is the name of the server crate.
* Run `cargo build` to check it builds.
* Run `cargo fmt` to reformat the code.
* Commit the result before making any further changes (lest format changes get confused with your own updates).

Now replace the implementations in `src/server.rs` with your own code as required.

## Updating your server to track API changes

Later, if the API changes, you can copy new sections  from the autogenerated API stub into your implementation.
Alternatively, implement the now-missing methods based on the compiler's error messages.

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Method | HTTP request | Description
------------- | ------------- | -------------
[****](docs/default_api.md#) | **GET** /op10 | 
[****](docs/default_api.md#) | **GET** /op11 | 
[****](docs/default_api.md#) | **GET** /op12 | 
[****](docs/default_api.md#) | **GET** /op13 | 
[****](docs/default_api.md#) | **GET** /op14 | 
[****](docs/default_api.md#) | **GET** /op15 | 
[****](docs/default_api.md#) | **GET** /op16 | 
[****](docs/default_api.md#) | **GET** /op17 | 
[****](docs/default_api.md#) | **GET** /op18 | 
[****](docs/default_api.md#) | **GET** /op19 | 
[****](docs/default_api.md#) | **GET** /op1 | 
[****](docs/default_api.md#) | **GET** /op20 | 
[****](docs/default_api.md#) | **GET** /op21 | 
[****](docs/default_api.md#) | **GET** /op22 | 
[****](docs/default_api.md#) | **GET** /op23 | 
[****](docs/default_api.md#) | **GET** /op24 | 
[****](docs/default_api.md#) | **GET** /op25 | 
[****](docs/default_api.md#) | **GET** /op26 | 
[****](docs/default_api.md#) | **GET** /op27 | 
[****](docs/default_api.md#) | **GET** /op28 | 
[****](docs/default_api.md#) | **GET** /op29 | 
[****](docs/default_api.md#) | **GET** /op2 | 
[****](docs/default_api.md#) | **GET** /op30 | 
[****](docs/default_api.md#) | **GET** /op31 | 
[****](docs/default_api.md#) | **GET** /op32 | 
[****](docs/default_api.md#) | **GET** /op33 | 
[****](docs/default_api.md#) | **GET** /op34 | 
[****](docs/default_api.md#) | **GET** /op35 | 
[****](docs/default_api.md#) | **GET** /op36 | 
[****](docs/default_api.md#) | **GET** /op37 | 
[****](docs/default_api.md#) | **GET** /op3 | 
[****](docs/default_api.md#) | **GET** /op4 | 
[****](docs/default_api.md#) | **GET** /op5 | 
[****](docs/default_api.md#) | **GET** /op6 | 
[****](docs/default_api.md#) | **GET** /op7 | 
[****](docs/default_api.md#) | **GET** /op8 | 
[****](docs/default_api.md#) | **GET** /op9 | 


## Documentation For Models



## Documentation For Authorization
 Endpoints do not require authorization.


## Author



